HDU1213:How Many Tables(并查集)

How Many Tables

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 46694    Accepted Submission(s): 23319

题目链接http://acm.hdu.edu.cn/showproblem.php?pid=1213

Description:

Today is Ignatius' birthday. He invites a lot of friends. Now it's dinner time. Ignatius wants to know how many tables he needs at least. You have to notice that not all the friends know each other, and all the friends do not want to stay with strangers.

One important rule for this problem is that if I tell you A knows B, and B knows C, that means A, B, C know each other, so they can stay in one table.

For example: If I tell you A knows B, B knows C, and D knows E, so A, B, C can stay in one table, and D, E have to stay in the other one. So Ignatius needs 2 tables at least.

Input:

The input starts with an integer T(1<=T<=25) which indicate the number of test cases. Then T test cases follow. Each test case starts with two integers N and M(1<=N,M<=1000). N indicates the number of friends, the friends are marked from 1 to N. Then M lines follow. Each line consists of two integers A and B(A!=B), that means friend A and friend B know each other. There will be a blank line between two cases.

Output:

For each test case, just output how many tables Ignatius needs at least. Do NOT print any blanks.

Sample Input:

2
5 3
1 2
2 3
4 5

5 1
2 5

Sample Output:

2
4

题意:

给出n个人,然后说明他们是否认识,并且这个关系能够传递。问至少有多少个集合,在这个集合里面的人互相认识。

题解:

由于这个关系可以传递,可以用并查集求解,这可以说是个并查集基础题。

代码如下:

#include <cstdio>
#include <cstring>
#include <algorithm>
#include <iostream>
using namespace std;

const int N = 1005;
int t,n,m;
int f[N];
int find(int x){
    return x==f[x] ? f[x] :f[x]=find(f[x]);
}
int main(){
    scanf("%d",&t);
    while(t--){
        scanf("%d%d",&n,&m);
        for(int i=1;i<=n+1;i++) f[i]=i;
        for(int i=1,x,y;i<=m;i++){
            scanf("%d%d",&x,&y);
            int fx=find(x),fy=find(y);
            f[fx]=fy;
        }
        int ans = 0;
        for(int i=1;i<=n;i++){
            int fi = find(i);
            if(fi==i) ans++;
        }
        printf("%d
",ans);
    }
    
    return 0;
}
原文地址:https://www.cnblogs.com/heyuhhh/p/9998545.html